
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <nds.h>

#include "_const.h"
#include "maindef.h"
#include "_console.h"
#include "_consoleWriteLog.h"

#include "plugin/plug_ndsrom.h"

#include "memtool.h"
#include "strpcm.h"
#include "dll.h"
#include "dllsound.h"
#include "lang.h"
#include "resume.h"
#include "procstate.h"
#include "launchstate.h"
#include "shell.h"
#include "skin.h"
#include "extmem.h"
#include "splash.h"
#include "BootROM.h"
#include "ErrorDialog.h"
#include "component.h"

#include "../../ipc6.h"

#include "arm9tcm.h"
#include "setarm9_reg_waitcr.h"

#include "fat2.h"
#include "zlibhelp.h"

#include "sndeff.h"
#include "datetime.h"

#include "fpga_helper.h"

extern "C" {
extern u32 dtcmend;
extern u32 mtcmend;
}

static u32 *pDTCMEND,*pMTCMEND;

#define StackStart (0x02803f00)

CglFont *pCglFontDefault=NULL;

void (*CallBack_Start)(void);
void (*CallBack_VsyncUpdate)(u32 VsyncCount);
void (*CallBack_End)(void);
void (*CallBack_KeyDown)(u32 Keys);
void (*CallBack_KeyPress)(u32 VsyncCount,u32 Keys);
void (*CallBack_KeyUp)(u32 Keys);
void (*CallBack_MouseDown)(s32 x,s32 y);
void (*CallBack_MouseMove)(s32 x,s32 y);
void (*CallBack_MouseUp)(s32 x,s32 y);
void (*CallBack_strpcmRequestStop)(void);
void (*CallBack_PanelOpen)(void);
void (*CallBack_PanelClose)(void);
void (*CallBack_VBlankHandler)(void);
void (*CallBack_ROMEO2_HPSwitch_ProcStart)(EROMEO2_TriggerType TriggerType);
void (*CallBack_ROMEO2_HPSwitch_ProcEnd)(EROMEO2_TriggerType TriggerType);
void (*CallBack_ROMEO2_HPSwitch_Down)(EROMEO2_TriggerType TriggerType);
void (*CallBack_ROMEO2_HPSwitch_Up)(EROMEO2_TriggerType TriggerType);
void (*CallBack_ROMEO2_HPSwitch_LongStart)(EROMEO2_TriggerType TriggerType);
void (*CallBack_ROMEO2_HPSwitch_LongEnd)(EROMEO2_TriggerType TriggerType);
void (*CallBack_ROMEO2_HPSwitch_SingleClick)(EROMEO2_TriggerType TriggerType);
void (*CallBack_ROMEO2_HPSwitch_SingleLongStart)(EROMEO2_TriggerType TriggerType);
void (*CallBack_ROMEO2_HPSwitch_SingleLongEnd)(EROMEO2_TriggerType TriggerType);
void (*CallBack_ROMEO2_HPSwitch_DoubleClick)(EROMEO2_TriggerType TriggerType);
void (*CallBack_ROMEO2_HPSwitch_DoubleLongStart)(EROMEO2_TriggerType TriggerType);
void (*CallBack_ROMEO2_HPSwitch_DoubleLongEnd)(EROMEO2_TriggerType TriggerType);
void (*CallBack_ROMEO2_HPSwitch_TripleClick)(EROMEO2_TriggerType TriggerType);
void (*CallBack_ExternalPowerAttach)(void);
void (*CallBack_ExternalPowerDetach)(void);

bool isExistsROMEO2;

ENextProc NextProc;

UnicodeChar RelationalFilePathUnicode[MaxFilenameLength];
UnicodeChar RelationalFileNameUnicode[MaxFilenameLength];
u32 RelationalFilePos;

ETextEncode ManualTextEncode;
bool ManualTextEncode_OverrideFlag;

// ------------------------------------------------------------------

void ShowLogHalt(void)
{
  _consoleLogResume();
  IPC6->LCDPowerControl=LCDPC_ON_BOTH;
  videoSetModeSub(MODE_2_2D | DISPLAY_BG2_ACTIVE);
  
  _consoleSetLogOutFlag(true);
  
  _consolePrint("\n     Application halted!!\n");
  
  if(_consoleGetLogFile()==true){
    _consolePrint("Please refer [/moonshl2/logbuf.txt]\n\n");
    }else{
    _consolePrint("\n");
  }
  while(1);
}

static __attribute__ ((always_inline)) void _ttywrch_tx_waitsend(const u32 data)
{
	while((*((vu8 *)0x0A000001) & 2)!=0);
	*((vu8 *)0x0A000000)=(u8)data;
}

extern "C" {
extern void _ttywrch(int ch);
}

void _ttywrch(int ch)
{
  _ttywrch_tx_waitsend(0xa0);
  _ttywrch_tx_waitsend(2);
  _ttywrch_tx_waitsend((u32)ch);
}

// ------------------------------------------------------

#include "chrglyph_999.h"

static void LoadDefaultFont(void)
{
  if(pCglFontDefault!=NULL){
    delete pCglFontDefault; pCglFontDefault=NULL;
  }
  pCglFontDefault=new CglFont(chrglyph_999,chrglyph_999_Size);
  
  pScreenMain->pBackCanvas->SetCglFont(pCglFontDefault);
  pScreenMain->pViewCanvas->SetCglFont(pCglFontDefault);
  pScreenMainOverlay->pCanvas->SetCglFont(pCglFontDefault);
  pScreenSub->pCanvas->SetCglFont(pCglFontDefault);
}

static void LangInitAndLoadFont(void)
{
  Shell_FAT_fopen_LanguageInit();
  
  FAT_FILE *pf=Shell_FAT_fopen_Language_chrglyph();
  if(pf==NULL){
    _consolePrintf("Fatal error: Can not found font file.\n");
    ShowLogHalt();
  }
  
  u32 bufsize=FAT2_GetFileSize(pf);
  void *pdummy=(u8*)safemalloc((bufsize*2)+(192*1024));
  u8 *pbuf=(u8*)safemalloc(bufsize);
  
  FAT2_fread_fast(pbuf,1,bufsize,pf);
  FAT2_fclose(pf);
  
  safefree(pdummy); pdummy=NULL;
  
  if(pCglFontDefault!=NULL){
    delete pCglFontDefault; pCglFontDefault=NULL;
  }
  pCglFontDefault=new CglFont((const u8*)pbuf,bufsize);
  
  safefree(pbuf); pbuf=NULL;
  
  pScreenMain->pBackCanvas->SetCglFont(pCglFontDefault);
  pScreenMain->pViewCanvas->SetCglFont(pCglFontDefault);
  pScreenMainOverlay->pCanvas->SetCglFont(pCglFontDefault);
  pScreenSub->pCanvas->SetCglFont(pCglFontDefault);
}

#include "bootwarn_b8zlib.h"

static void DrawBootWarn(void)
{
  TZLIBData zd;
  
  zd.DstSize=ScreenWidth*ScreenHeight;
  zd.pDstBuf=(u8*)safemalloc(zd.DstSize);
  zd.SrcSize=bootwarn_b8zlib_Size;
  zd.pSrcBuf=(u8*)bootwarn_b8zlib;
  
  if((zd.pSrcBuf[0]!=0x78)||(zd.pSrcBuf[1]!=0x01)){
    _consolePrintf("Fatal error: Unknown compress format.\n");
    ShowLogHalt();
  }

  if(zlibdecompress(&zd)==false){
    _consolePrintf("Fatal error: ZLIB decompress error.\n");
    ShowLogHalt();
  }
  
  u16 pals[3]={RGB15(24,0,0)|BIT15,RGB15(28,26,27)|BIT15,RGB15(0,0,0)|BIT15};
  
  u16 *psrc=(u16*)zd.pDstBuf;
  u32 *pdst=(u32*)pScreenMain->pViewCanvas->GetVRAMBuf();
  for(u32 idx=0;idx<(ScreenWidth*ScreenHeight)/2;idx++){
    u32 pal16=*psrc++;
    u32 col32=pals[pal16&0xff]|(pals[pal16>>8]<<16);
    *pdst++=col32;
  }
  
  zd.DstSize=0;
  safefree(zd.pDstBuf); zd.pDstBuf=NULL;
}

// ----------------------------------------

static void mainloop(void);

int main(void)
{
  REG_IME=0;
  
  u32 zero;
  asm {
    mov zero,#0
    MCR p15, 0, zero, c7, c10, 4 // drain write buffer
  }
  
  SetARM9_REG_WaitCR();
  
  REG_POWERCNT = POWER_ALL_2D; // | POWER_SWAP_LCDS;
  
  atype_init();
  
  glSetFuncDebugPrint(_consolePrint);
  glDefaultMemorySetting();
  
  {
    SUB_BG2_CR = BG_256_COLOR | BG_RS_64x64 | BG_MAP_BASE(8) | BG_TILE_BASE(0) | BG_PRIORITY_1; // Tile16kb Map2kb(64x32)
    
    BG_PALETTE_SUB[(0*16)+0] = RGB15(0,0,0); // unuse (transparent)
    BG_PALETTE_SUB[(0*16)+1] = RGB15(0,0,2) | BIT(15); // BG color
    BG_PALETTE_SUB[(0*16)+2] = RGB15(0,0,0) | BIT(15); // Shadow color
    BG_PALETTE_SUB[(0*16)+3] = RGB15(16,16,16) | BIT(15); // Text color
    
    u16 XDX=(u16)((8.0/6)*0x100);
    u16 YDY=(u16)((8.0/6)*0x100);
    
    SUB_BG2_XDX = XDX;
    SUB_BG2_XDY = 0;
    SUB_BG2_YDX = 0;
    SUB_BG2_YDY = YDY;
    
    SUB_BG2_CX=1;
    SUB_BG2_CY=-1;
    
    //consoleInit() is a lot more flexible but this gets you up and running quick
    _consoleInitDefault((u16*)(SCREEN_BASE_BLOCK_SUB(8)), (u16*)(CHAR_BASE_BLOCK_SUB(0)));
  }
  
  _consolePrintf("boot %s %s\n%s\n%s\n\n",ROMTITLE,ROMVERSION,ROMDATE,ROMENV);
  _consolePrintf("__current pc=0x%08x sp=0x%08x\n\n",__current_pc(),__current_sp());
  PrintFreeMem();

/*
  PSRAM_Write32bit(0,58);
  _consolePrintf("Read PSRAM(0,58) = %d.\n", PSRAM_Read32bit(0));
  while(1);
*/
  
  glDefaultClassCreate();
  LoadDefaultFont();
  
  _consolePrintf("%x,%x\n",IPC6,&IPC6->ARM7SelfCheck);
  
  DrawBootWarn();
  
  pDTCMEND=(u32*)&dtcmend;
  pDTCMEND+=128/4;
  
  {
    // stack overflow checker
    u32 *p=pDTCMEND;
    _consolePrintf("DTCMEND=0x%x\n",p);
    for(;p<(u32*)__current_sp();p++){
      *p=(u32)p;
    }
  }
  
  pMTCMEND=(u32*)&mtcmend;
  
  if((0x02804000-1536)<(u32)pMTCMEND){
    _consolePrintf("MTCM overflow. 0x%08x 0x%08x\n",0x02800000+1536,pMTCMEND);
    ShowLogHalt();
  }
  
  SetARM9_REG_WaitCR();
  extmem_Init();
  extmem_ShowMemoryInfo();
  
  SetARM9_REG_WaitCR();
  if(FAT2_InitFiles()==false){
    _consolePrint("FAT_InitFiles() failed.\n");
    ShowLogHalt();
  }
  SetARM9_REG_WaitCR();
  
  if(Shell_FAT_fopen_isExists_Data(LogFilename)==true){
    FAT_FILE *pf=Shell_FAT_fopen_Data(LogFilename);
    if(pf!=NULL){
      _consoleSetLogFile(pf);
      FAT2_fclose(pf);
    }
  }
  
  _consolePrintf("Start FPGA Initializer.\n");
  FPGA_BusOwnerARM9();
  if(FPGA_isExistCartridge()==false){
    isExistsROMEO2=false;
    _consolePrintf("Fatal error: Can not found ROMEO2 cartridge on GBA slot.\n");
    }else{
    bool halt=true;
    void *pFPGAData=NULL;
    s32 FPGADataSize=0;
    if(Shell_FAT_ReadAlloc(FPGAFilename,&pFPGAData,&FPGADataSize)==false){
      _consolePrintf("Can not found RAW file. [%s]\n",FPGAFilename);
      }else{
      if(FPGA_CheckBitStreamFormat(pFPGAData,FPGADataSize)==false){
        _consolePrintf("Fatal error: ROMEO2 FPGA bit stream unknown format?\n");
        }else{
        if(FPGA_Start(pFPGAData,FPGADataSize)==false){
          _consolePrintf("Fatal error: ROMEO2 configration failed.\n");
          }else{
          FPGA_BusOwnerARM7();
          _consolePrintf("Wait for ARM7 init.\n");
          IPC6->RequestFPGAInit=true;
          while(IPC6->RequestFPGAInit==true);
          _consolePrintf("Initialized.\n");
          halt=false;
          isExistsROMEO2=true;
        }
      }
      safefree(pFPGAData); pFPGAData=NULL;
    }
    if(halt==true) ShowLogHalt();
  }
  
  {
    DateTime_ResetNow();
    TDateTime dt=DateTime_GetNow();
    TFAT2_TIME ft;
    
    ft.Year=dt.Date.Year;
    ft.Month=dt.Date.Month;
    ft.Day=dt.Date.Day;
    ft.Hour=dt.Time.Hour;
    ft.Minuts=dt.Time.Min;
    ft.Second=dt.Time.Sec;
    
    FAT2_SetSystemDateTime(ft);
  }
  
  IPC6->LCDPowerControl=LCDPC_ON_BOTH;
  
  Shell_CheckDataPath();
  
  InitInterrupts();
  strpcmSetVolume64(64);
  
  if(true){
    u32 UserLanguage=(u32)-1;
    u32 Timeout=0x10000;
    
    while(UserLanguage==(u32)-1){
      UserLanguage=IPC6->UserLanguage;
      Timeout--;
      if(Timeout==0){
        _consolePrintf("NDS farmware language read error. ARM7CPU stopped...?\n");
        while(1);
      }
    }
    _consolePrintf("NDS farmware language ID : %d %08x\n",UserLanguage);
  }
  
  LangInitAndLoadFont();
  
  {
    SetARM9_REG_WaitCR();
    PrintFreeMem();
    mainloop();
    PrintFreeMem();
  }
  
  REG_IME=0;
  
  FAT2_FreeFiles();
  
  glDefaultClassFree();
  
  _consolePrint("Terminated.\n");
  ShowLogHalt();
  
  return(0);
}

// -------------------------------- mainloop

void WaitForVBlank(void)
{
  if(VBlankPassedFlag==false){
    swiWaitForVBlank();
  }
  VBlankPassedFlag=false;
}

static bool mf;
static s32 mx,my;

static void Proc_TouchPad(u32 VsyncCount)
{
  if(IPC6->RequestUpdateIPC==true) return;
  
  bool tpress;
  s32 tx,ty;
  
  if((IPC6->buttons&IPC_PEN_DOWN)==0){
    tpress=false;
    tx=0;
    ty=0;
    }else{
    tpress=true;
    tx=IPC6->touchXpx;
    ty=IPC6->touchYpx;
  }
  
  IPC6->RequestUpdateIPC=true;
  
  if(tpress==true){
    if(mf==false){
      mf=true;
      if(CallBack_MouseDown!=NULL) CallBack_MouseDown(tx,ty);
      mx=tx;
      my=ty;
      }else{
      s32 dx=abs(mx-tx);
      s32 dy=abs(my-ty);
      if((1<=dx)||(1<=dy)){
        if(CallBack_MouseMove!=NULL) CallBack_MouseMove(tx,ty);
        mx=tx;
        my=ty;
      }
    }
    }else{
    if(mf==true){
      mf=false;
      if(CallBack_MouseUp!=NULL) CallBack_MouseUp(mx,my);
    }
  }
}

#include "main_keyrepeat.h"

static u32 KEYS_Last;
static bool KEYS_PressedLR;
static bool KEYS_HPSwitch_Pressed;

void Proc_KeyInput_Init(void)
{
  KEYS_Last=~0;
  KEYS_PressedLR=false;
  KEYS_HPSwitch_Pressed=false;
}

//#define WriteBMPFunction

#ifdef WriteBMPFunction
#include "main_savepreview.h"
#endif

void Proc_KeyInput(u32 VsyncCount)
{
  if(KeyRepeatFlag==true){ cwl();
    if(KeyRepeatCount<=VsyncCount){ cwl();
      KeyRepeatCount=0;
      }else{ cwl();
      KeyRepeatCount-=VsyncCount;
    }
  }
  
  u32 KEYS_Cur=(~REG_KEYINPUT)&0x3ff;
  
#ifdef WriteBMPFunction
  if((KEYS_Cur & KEY_SELECT)!=0) main_SavePreviewAndHalt();
#endif
  
  {
    u32 btns=IPC6->buttons;
    
    KEYS_Cur|=(~REG_KEYINPUT)&0x3ff;
    if((btns&IPC_PEN_DOWN)!=0) KEYS_Cur|=KEY_TOUCH;
    if((btns&IPC_X)!=0) KEYS_Cur|=KEY_X;
    if((btns&IPC_Y)!=0) KEYS_Cur|=KEY_Y;
  }
  
  if((KEYS_Last&(KEY_L|KEY_R))==0){
    if((KEYS_Cur&(KEY_L|KEY_R))!=0){
      if(KEYS_PressedLR==false){
        KEYS_PressedLR=true;
        if(CallBack_KeyDown!=NULL) CallBack_KeyDown(KEY_L|KEY_R);
      }
    }
  }
  if((KEYS_Last&(KEY_L|KEY_R))!=0){
    if((KEYS_Cur&(KEY_L|KEY_R))==0){
      if(KEYS_PressedLR==true){
        KEYS_PressedLR=false;
        if(CallBack_KeyDown!=NULL) CallBack_KeyUp(KEY_L|KEY_R);
      }
    }
  }
  
  KEYS_Last=KEYS_Cur;
  KEYS_Cur=KeyRepeat_Proc(KEYS_Cur,VsyncCount);
  
  if(8<VsyncCount) VsyncCount=8;
  
  if(KEYS_Cur!=0){
    if(CallBack_KeyPress!=NULL) CallBack_KeyPress(VsyncCount,KEYS_Cur);
  }
  
}

static bool Proc_PanelOpened_Last;

static void Proc_PanelOpened(void)
{
  if(Proc_PanelOpened_Last!=IPC6->PanelOpened){
    Proc_PanelOpened_Last=IPC6->PanelOpened;
    if(Proc_PanelOpened_Last==true){
      if(CallBack_PanelOpen!=NULL) CallBack_PanelOpen();
      }else{
      if(CallBack_PanelClose!=NULL) CallBack_PanelClose();
    }
  }
}

#include "main_ROMEO2_HPSwitch.h"

// ------------------------------------------------------------

static void CallBackInit(void)
{
  CallBack_Start=NULL;
  CallBack_VsyncUpdate=NULL;
  CallBack_End=NULL;
  CallBack_KeyDown=NULL;
  CallBack_KeyPress=NULL;
  CallBack_KeyUp=NULL;
  CallBack_MouseDown=NULL;
  CallBack_MouseMove=NULL;
  CallBack_MouseUp=NULL;
  CallBack_strpcmRequestStop=NULL;
  CallBack_PanelOpen=NULL;
  CallBack_PanelClose=NULL;
  CallBack_VBlankHandler=NULL;
  CallBack_ROMEO2_HPSwitch_Down=NULL;
  CallBack_ROMEO2_HPSwitch_Up=NULL;
  CallBack_ROMEO2_HPSwitch_LongStart=NULL;
  CallBack_ROMEO2_HPSwitch_LongEnd=NULL;
  CallBack_ROMEO2_HPSwitch_SingleClick=NULL;
  CallBack_ROMEO2_HPSwitch_SingleLongStart=NULL;
  CallBack_ROMEO2_HPSwitch_SingleLongEnd=NULL;
  CallBack_ROMEO2_HPSwitch_DoubleClick=NULL;
  CallBack_ROMEO2_HPSwitch_DoubleLongStart=NULL;
  CallBack_ROMEO2_HPSwitch_DoubleLongEnd=NULL;
  CallBack_ROMEO2_HPSwitch_TripleClick=NULL;
  CallBack_ExternalPowerAttach=NULL;
  CallBack_ExternalPowerDetach=NULL;
}

// ------------------------------------------------------------

EProcFadeEffect ProcFadeEffect;

static const u32 HorizontalFadeStepCount=35;
static const u32 HorizontalFadeStep[HorizontalFadeStepCount]={2,4,4,6,6,8,8,8,8,10,10,10,10,10,10,10,10,10,10,10,10,8,8,8,8,8,8,6,6,6,4,4,4,2,2,};

static const u32 VerticalFadeStepCount=27;
static const u32 VerticalFadeStep[VerticalFadeStepCount]={2,4,5,7,8,8,9,9,9,9,9,9,9,9,9,9,9,9,8,8,7,7,6,5,4,3,2,};

void ScreenMain_Flip_ProcFadeEffect(void)
{
  if(NextProc!=ENP_Loop) return;
  
  if(ProcState.System.EnableFadeEffect==false) ProcFadeEffect=EPFE_None;
  
  u16 *pviewbuf=pScreenMain->pViewCanvas->GetVRAMBuf();
  u16 *pbackbuf=pScreenMain->pBackCanvas->GetVRAMBuf();
  
  switch(ProcFadeEffect){
    case EPFE_None: {
    } break;
    case EPFE_LeftToRight: {
      u32 sx=0;
      for(u32 idx=0;idx<HorizontalFadeStepCount;idx++){
        u32 step=HorizontalFadeStep[idx];
        Splash_Update();
        swiWaitForVBlank();
        u16 tmpbuf[ScreenWidth];
        for(u32 y=0;y<ScreenHeight;y++){
          u16 *pviewlinebuf=&pviewbuf[y*ScreenWidth];
          u16 *pbacklinebuf=&pbackbuf[y*ScreenWidth];
          MemCopy32CPU(&pviewlinebuf[0],tmpbuf,(ScreenWidth-step)*2);
          MemCopy32CPU(tmpbuf,&pviewlinebuf[step],(ScreenWidth-step)*2);
          MemCopy32CPU(&pbacklinebuf[ScreenWidth-step-sx],&pviewlinebuf[0],step*2);
        }
        sx+=step;
      }
    } break;
    case EPFE_RightToLeft: {
      u32 sx=0;
      for(u32 idx=0;idx<HorizontalFadeStepCount;idx++){
        u32 step=HorizontalFadeStep[idx];
        Splash_Update();
        swiWaitForVBlank();
        for(u32 y=0;y<ScreenHeight;y++){
          u16 *pviewlinebuf=&pviewbuf[y*ScreenWidth];
          u16 *pbacklinebuf=&pbackbuf[y*ScreenWidth];
          MemCopy32CPU(&pviewlinebuf[step],&pviewlinebuf[0],(ScreenWidth-step)*2);
          MemCopy32CPU(&pbacklinebuf[sx],&pviewlinebuf[ScreenWidth-step],step*2);
        }
        sx+=step;
      }
    } break;
    case EPFE_UpToDown: {
      u32 sy=0;
      for(u32 idx=0;idx<VerticalFadeStepCount;idx++){
        u32 step=VerticalFadeStep[idx];
        Splash_Update();
        swiWaitForVBlank();
        s32 y;
        y=ScreenHeight-(step*2);
        y=(y/step)*step;
        for(;y>=0;y-=step){
          u16 *pviewlinebuf=&pviewbuf[y*ScreenWidth];
          MemCopy32CPU(&pviewlinebuf[0*ScreenWidth],&pviewlinebuf[step*ScreenWidth],(step*ScreenWidth)*2);
        }
        u16 *pviewlinebuf=&pviewbuf[0*ScreenWidth];
        u16 *pbacklinebuf=&pbackbuf[0*ScreenWidth];
        MemCopy32CPU(&pbacklinebuf[(ScreenHeight-step-sy)*ScreenWidth],&pviewlinebuf[0*ScreenWidth],(step*ScreenWidth)*2);
        sy+=step;
      }
    } break;
    case EPFE_DownToUp: {
      u32 sy=0;
      for(u32 idx=0;idx<VerticalFadeStepCount;idx++){
        u32 step=VerticalFadeStep[idx];
        Splash_Update();
        swiWaitForVBlank();
        for(u32 y=0;y<ScreenHeight-step;y+=step){
          u16 *pviewlinebuf=&pviewbuf[y*ScreenWidth];
          MemCopy32CPU(&pviewlinebuf[step*ScreenWidth],&pviewlinebuf[0*ScreenWidth],(step*ScreenWidth)*2);
        }
        u16 *pviewlinebuf=&pviewbuf[0*ScreenWidth];
        u16 *pbacklinebuf=&pbackbuf[0*ScreenWidth];
        MemCopy32CPU(&pbacklinebuf[sy*ScreenWidth],&pviewlinebuf[(ScreenHeight-step)*ScreenWidth],(step*ScreenWidth)*2);
        sy+=step;
      }
    } break;
    case EPFE_CrossFade: {
      for(u32 idx=16;idx>0;idx--){
        Splash_Update();
        WaitForVBlank();
        pScreenMain->SetBlendLevel(idx);
        while(VBlankPassedFlag==false){
          DLLSound_Update();
        }
      }
    } break;
    case EPFE_FastCrossFade: {
      for(u32 idx=16;idx>0;idx-=4){
        Splash_Update();
        WaitForVBlank();
        pScreenMain->SetBlendLevel(idx);
        while(VBlankPassedFlag==false){
          DLLSound_Update();
        }
      }
    } break;
  }
  pScreenMain->Flip(true);
  
  if(ProcFadeEffect!=EPFE_None){
    ProcFadeEffect=EPFE_None;
    REG_IME=0;
    VBlankPassedCount=1;
    REG_IME=1;
  }
}

// ------------------------------------------------------------

static void Proc_ExternalPowerPresent(void)
{
  static bool LastState;
  
  static bool FirstStart=true;
  if(FirstStart==true){
    FirstStart=false;
    LastState=IPC6->ExternalPowerPresent;
    return;
  }
  
  bool curstate=IPC6->ExternalPowerPresent;
  if(LastState==curstate) return;
  LastState=curstate;
  
  if(curstate==true){
    if(CallBack_ExternalPowerAttach!=NULL) CallBack_ExternalPowerAttach();
    }else{
    if(CallBack_ExternalPowerDetach!=NULL) CallBack_ExternalPowerDetach();
  }
}

// ------------------------------------------------------------

static void mainloop_autoboot(const char *pFilename)
{
  const UnicodeChar PathUnicode[2]={(UnicodeChar)'/',0};
  UnicodeChar FilenameUnicode[16];
  StrConvert_Ank2Unicode(pFilename,FilenameUnicode);
  if(FileExistsUnicode(PathUnicode,FilenameUnicode)==true){
    _consolePrintf("Auto booting... [/%s]\n",pFilename);
    BootROM_SetInfo_NoLaunch(PathUnicode,FilenameUnicode,true);
  }
}

static void mainloop(void)
{
  _consolePrint("mainloop.\n");
  
  Lang_Load();
  
  Splash_Init();
  
  if(true){
    _consolePrintf("Initialize random seed.\n");
    DateTime_ResetNow();
    TDateTime now=DateTime_GetNow();
    u32 cnt=((now.Time.Min*60)+now.Time.Sec)&0xff;
    for(u32 idx=0;idx<cnt;idx++){
      rand();
    }
  }
  
  ErrorDialog_Init();
  
  Component_SetFont(pCglFontDefault);
  
  ProcState_Init();
  
  {
    u32 keys=(~REG_KEYINPUT)&0x3ff;
    if(keys==(KEY_A|KEY_B|KEY_L|KEY_R)){
      ProcState_Clear();
      ProcState_RequestSave=true;
      ProcState_Save();
      LaunchState_Init();
      LaunchState_Save();
      Skin_ClearCustomBG_FileBody();
      Skin_ClearCustomBG();
      
      pScreenSub->pCanvas->SetFontTextColor(RGB15(31,31,31)|BIT15);
      pScreenSub->pCanvas->TextOutA(8,96,"All settings were initialized.");
      pScreenSub->pCanvas->TextOutA(8,96+16,"Please release all key.");
    }
  }
  
  ProcState_Load();
  LaunchState_Load();
  Resume_Load();
  
  ApplyCurrentBacklightLevel();
  strpcmSetVolume64(ProcState.System.Volume64);
  
  BootROM_Init();
  
  Shell_Init_SwapFile();
  
  mf=false;
  mx=0;
  my=0;
  
  KEYS_Last=0;
  KeyRepeatLastKey=0;
  KeyRepeatFlag=false;
  KeyRepeatCount=0;
  
  DLLList_Init();
  Splash_Update();
  
  Sound_Init();
  Splash_Update();
  
  {
    UnicodeChar *pcpu=ProcState.FileList.CurrentPathUnicode;
    const char *pafn=StrConvert_Unicode2Ank_Test(pcpu);
    _consolePrintf("Check current path. [%s]\n",pafn);
    const char *pPathAlias=ConvertFull_Unicode2Alias(pcpu,NULL);
    if(pPathAlias==NULL){
      _consolePrintf("Set to default path.\n");
      pcpu[0]=(UnicodeChar)'/';
      pcpu[1]=(UnicodeChar)0;
      }else{
      if(FAT2_chdir_Alias(pPathAlias)==false){
        _consolePrintf("Set to default path.\n");
        pcpu[0]=(UnicodeChar)'/';
        pcpu[1]=(UnicodeChar)0;
        }else{
        _consolePrintf("finded. [%s]\n",pPathAlias);
      }
    }
  }
  
  Skin_ClearCustomBG();
  
  _consolePrintf("Set skin.\n");
  if(Skin_SetFilename(ProcState.System.SkinFilenameUnicode)==false){
    _consolePrintf("Set default skin.\n");
    StrConvert_Ank2Unicode(DefaultDataPath "/default.skn",ProcState.System.SkinFilenameUnicode);
    if(Skin_SetFilename(ProcState.System.SkinFilenameUnicode)==false){
      _consolePrintf("Not found skin package.\n");
      ShowLogHalt();
    }
  }
  
  PrintFreeMem();
  Splash_Update();

  VBlankPassedFlag=false;
  VBlankPassedCount=0;
  
  _consolePrintf("Set NextProc.\n");
  
  RelationalFile_Clear();
  
  NextProc=ENP_Loop;
  
  {
    u32 KEYS_Cur=(~REG_KEYINPUT)&0x3ff;
    {
      u32 btns=IPC6->buttons;
      KEYS_Cur|=(~REG_KEYINPUT)&0x3ff;
      if((btns&IPC_PEN_DOWN)!=0) KEYS_Cur|=KEY_TOUCH;
      if((btns&IPC_X)!=0) KEYS_Cur|=KEY_X;
      if((btns&IPC_Y)!=0) KEYS_Cur|=KEY_Y;
    }
    if((NextProc==ENP_Loop)&&(KEYS_Cur==0)) mainloop_autoboot(DefaultNFilename);
    if((NextProc==ENP_Loop)&&(KEYS_Cur==KEY_X)) mainloop_autoboot(DefaultXFilename);
    if((NextProc==ENP_Loop)&&(KEYS_Cur==KEY_Y)) mainloop_autoboot(DefaultYFilename);
    if(NextProc!=ENP_Loop) Splash_Free();
  }
  
  atype_lockall();
  if(NextProc==ENP_Loop){
    atype_showallocated();
    atype_checkoverrange();
    atype_checkmemoryleak();
    Splash_Update();
  }
  
  if(NextProc==ENP_Loop){
    // Resume_SetResumeMode(ERM_None); // Disabled resume function.
    if(Resume_GetResumeMode()!=ERM_None){
      _consolePrintf("Restart resume.\n");
      UnicodeChar PathUnicode[MaxFilenameLength],FilenameUnicode[MaxFilenameLength];
      SplitItemFromFullPath(Resume_GetFilename(),PathUnicode,FilenameUnicode);
      if(FileExistsUnicode(PathUnicode,FilenameUnicode)==true){
        Unicode_Copy(RelationalFilePathUnicode,PathUnicode);
        Unicode_Copy(RelationalFileNameUnicode,FilenameUnicode);
        Unicode_Copy(ProcState.FileList.CurrentPathUnicode,PathUnicode);
        Unicode_Copy(ProcState.FileList.SelectFilenameUnicode,FilenameUnicode);
        RelationalFilePos=Resume_GetPos();
        Splash_Free();
        switch(Resume_GetResumeMode()){
          case ERM_None: break;
          case ERM_Audio: {
            SetNextProc(ENP_FileList,EPFE_CrossFade);
          } break;
          case ERM_Video: {
            pScreenSub->pCanvas->FillFull(ColorTable.Video.InitBG);
            SetNextProc(ENP_DPGPlay,EPFE_None);
          } break;
          case ERM_Image: {
            SetNextProc(ENP_ImageView,EPFE_None);
          } break;
          case ERM_Text: {
            SetNextProc(ENP_TextView,EPFE_None);
          } break;
        }
      }
      Resume_Clear();
    }
  }
  
  if(NextProc==ENP_Loop){
    if(ProcState.System.BootCheckDisk==false){
      if(ProcState.System.SkipSetup==false){
        SetNextProc(ENP_Setup,EPFE_CrossFade);
        }else{
        switch(ProcState.System.LastState){
          case ELS_FileList: SetNextProc(ENP_FileList,EPFE_CrossFade); break;
          case ELS_Launch: SetNextProc(ENP_Launch,EPFE_CrossFade); break;
        }
      }
      }else{
      SetNextProc(ENP_ChkDsk,EPFE_CrossFade);
    }
  }
  
//  SetNextProc(ENP_Custom,EPFE_CrossFade);
  
  Proc_PanelOpened_Last=IPC6->PanelOpened;
  
  {
    // stack overflow checker
    u32 *p=pDTCMEND;
    if(*p!=(u32)p){
      _consolePrintf("Fatal error: Stack overflow!!\n");
      ShowLogHalt();
    }
    for(;p<(u32*)__current_sp();p++){
      if(*p!=(u32)p) break;
    }
    _consolePrintf("Used stack size %dbyte.\nTotal stack size %dbyte.\n",StackStart-(u32)p,StackStart-(u32)pDTCMEND);
  }
  
  _consolePrintf("Event loop...\n");
  
  while(1){
    if(NextProc!=ENP_BootROM){
      _consolePrintf("Wait for key releases.\n");
      while(1){
        if(IPC6->RequestUpdateIPC==false){
          u32 btns=IPC6->buttons;
          u32 keys=(~REG_KEYINPUT)&0x3ff;
          if((btns&IPC_PEN_DOWN)!=0) keys|=KEY_TOUCH;
          if((btns&IPC_X)!=0) keys|=KEY_X;
          if((btns&IPC_Y)!=0) keys|=KEY_Y;
          if(keys==0) break;
          IPC6->RequestUpdateIPC=true;
        }
      }
    }
    
    bool chkstack=true;
    if(NextProc==ENP_DPGPlay) chkstack=false;
    
    if(chkstack==true){ // stack overflow checker
      u32 *p=pDTCMEND;
      for(;p<(u32*)(StackStart-0x400);p++){
        *p=(u32)p;
      }
      }else{
      u32 *p=pMTCMEND;
      for(;p<(u32*)(StackStart-0x400);p++){
        *p=(u32)p;
      }
    }
    
    CallBackInit();
    
    Skin_Free();
    
    switch(NextProc){
      case ENP_Loop: {
        _consolePrintf("Illigal process error! NextProc==ENP_Loop\n");
        ShowLogHalt();
      } break;
      case ENP_ChkDsk: Skin_Load_ChkDsk(); break;
      case ENP_Setup: Skin_Load_Setup(); break;
      case ENP_FileList: Skin_Load_FileList(); break;
      case ENP_SysMenu: Skin_Load_SysMenu(); break;
      case ENP_DPGPlay: Skin_ClearCustomBG(); Skin_Load_DPGPlay(); break;
      case ENP_ImageCustom: Skin_Load_ImageCustom(); break;
      case ENP_ImageView: Skin_Load_ImageView(); break;
      case ENP_TextCustom: Skin_Load_TextCustom(); break;
      case ENP_TextView: Skin_Load_TextView(); break;
      case ENP_Launch: Skin_Load_Launch(); break;
      case ENP_Custom: Skin_Load_Custom(); break;
      case ENP_BootROM: Skin_Load_BootROM(); break;
      default: {
        _consolePrintf("Unknown process error! NextProc==%d\n",NextProc);
        ShowLogHalt();
      } break;
    }
    
    if((NextProc==ENP_Setup)||(NextProc==ENP_FileList)||(NextProc==ENP_Launch)||(NextProc==ENP_Custom)||(NextProc==ENP_BootROM)) Splash_Free();
    
    switch(NextProc){
      case ENP_Loop: {
        _consolePrintf("Illigal process error! NextProc==ENP_Loop\n");
        ShowLogHalt();
      } break;
      case ENP_ChkDsk: ProcChkDsk_SetCallBack(); break;
      case ENP_Setup: ProcSetup_SetCallBack(); break;
      case ENP_FileList: ProcFileList_SetCallBack(); break;
      case ENP_SysMenu: ProcSysMenu_SetCallBack(); break;
      case ENP_DPGPlay: ProcDPGPlay_SetCallBack(); break;
      case ENP_ImageCustom: ProcImageCustom_SetCallBack(); break;
      case ENP_ImageView: ProcImageView_SetCallBack(); break;
      case ENP_TextCustom: ProcTextCustom_SetCallBack(); break;
      case ENP_TextView: ProcTextView_SetCallBack(); break;
      case ENP_Launch: ProcLaunch_SetCallBack(); break;
      case ENP_Custom: ProcCustom_SetCallBack(); break;
      case ENP_BootROM: ProcBootROM_SetCallBack(); break;
      default: {
        _consolePrintf("Unknown process error! NextProc==%d\n",NextProc);
        ShowLogHalt();
      } break;
    }
    
    NextProc=ENP_Loop;
    
    if(CallBack_Start!=NULL) CallBack_Start();
    
    if(chkstack==true){ // stack overflow checker
      u32 *p=pDTCMEND;
      if(*p!=(u32)p){
        _consolePrintf("Fatal error: Stack overflow!!\n");
        ShowLogHalt();
      }
    }
    
    ProcState_Save();
    
    atype_checkoverrange();
    
    PrintFreeMem();
    
    VBlankPassedFlag=false;
    VBlankPassedCount=0;
    Proc_TouchPad(0);
    Proc_KeyInput_Init();
    Proc_ROMEO2_HPSwitch(true,0);
    
    REG_IME=0;
    VBlankPassedCount=0;
    REG_IME=1;
    
    while(NextProc==ENP_Loop){
      if(DLLSound_isOpened()==true){
        while(DLLSound_Update()==true){
        }
        if(strpcmRequestStop==true){
          if(CallBack_strpcmRequestStop!=NULL) CallBack_strpcmRequestStop();
        }
      }
      
      WaitForVBlank();
      
      REG_IME=0;
      u32 vsynccount=VBlankPassedCount;
      VBlankPassedCount=0;
      REG_IME=1;
      
      if(CallBack_VsyncUpdate!=NULL) CallBack_VsyncUpdate(vsynccount);
      
      Proc_TouchPad(vsynccount);
      Proc_KeyInput(vsynccount);
      Proc_PanelOpened();
      Proc_ROMEO2_HPSwitch(false,vsynccount);
      Proc_ExternalPowerPresent();
      
      if(chkstack==true){ // stack overflow checker
        u32 *p=pDTCMEND;
        if(*p!=(u32)p){
          _consolePrintf("Fatal error: Stack overflow!!\n");
          ShowLogHalt();
        }
      }
      
    }
    
    VBlankPassedFlag=false;
    VBlankPassedCount=0;
    if(CallBack_End!=NULL) CallBack_End();
    
    IPC6->LCDPowerControl=LCDPC_ON_BOTH;
    
    atype_checkoverrange();
    atype_checkmemoryleak();
    
    if(chkstack==true){
      // stack overflow checker
      u32 *p=pDTCMEND;
      if(*p!=(u32)p){
        _consolePrintf("Fatal error: Stack overflow!!\n");
        ShowLogHalt();
      }
      for(;p<(u32*)__current_sp();p++){
        if(*p!=(u32)p) break;
      }
      _consolePrintf("Used stack size %dbyte.\nTotal stack size %dbyte.\n",StackStart-(u32)p,StackStart-(u32)pDTCMEND);
      }else{
      u32 *p=pMTCMEND;
      if(*p!=(u32)p){
        _consolePrintf("Fatal error: Stack overflow!!\n");
        ShowLogHalt();
      }
      for(;p<(u32*)__current_sp();p++){
        if(*p!=(u32)p) break;
      }
      _consolePrintf("Used stack size %dbyte.\nTotal stack size %dbyte.\n",StackStart-(u32)p,StackStart-(u32)pMTCMEND);
    }
    
    if(BootROM_GetExecuteFlag()==true) break;
    
  }
  
  Skin_Free();
  Skin_CloseFile();
  
  Lang_Free();
  
  Sound_Stop();
  Sound_Free();
  
  _consolePrint("mainloop terminated.\n");
  
  _consolePrintf("Reboot ROM '%s'\n",BootROM_GetFullPathAlias());
  BootNDSROM();
  ShowLogHalt();
}

