unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, _PicTools, ExtCtrls,math;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    prvimg: TImage;
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var
  rfs:TFileStream;

function rfs8bit:byte;
begin
  rfs.ReadBuffer(Result,1);
end;

function rfs16bit:word;
begin
  Result:=0;
  Result:=Result or (word(rfs8bit) shl 8);
  Result:=Result or (word(rfs8bit) shl 0);
end;

function rfs24bit:dword;
begin
  Result:=0;
  Result:=Result or (dword(rfs8bit) shl 16);
  Result:=Result or (dword(rfs8bit) shl 8);
  Result:=Result or (dword(rfs8bit) shl 0);
end;

function rfs32bit:dword;
begin
  Result:=0;
  Result:=Result or (dword(rfs8bit) shl 24);
  Result:=Result or (dword(rfs8bit) shl 16);
  Result:=Result or (dword(rfs8bit) shl 8);
  Result:=Result or (dword(rfs8bit) shl 0);
end;

procedure rfsskip(size:integer);
begin
  rfs.Position:=rfs.Position+size;
end;

function rfsGetPos:dword;
begin
  Result:=rfs.Position;
end;

procedure rfsSetPos(ofs:dword);
begin
  rfs.Position:=ofs;
end;

type
  TPSDHead=record
    Signature:array[0..4-1] of char;
    Version:word;
    Channels:word;
    Height:dword;
    Width:dword;
    BitPerChannel:word;
    Mode:word;
    Palette:array[0..256-1] of TRGB;
    Compression:word;
    ImageDataOffset:integer;
    RLETableCount:integer;
    RLEOffsetTable:array of dword;
    RLESizeTable:array of word;
    RLEDataOffset:integer;
    RLESizeMax:integer;
  end;

var
  PSDHead:TPSDHead;

const PSDMODE_Bitmap=0;
const PSDMODE_Grayscale=1;
const PSDMODE_Indexed=2;
const PSDMODE_RGB=3;
const PSDMODE_CMYK=4;
const PSDMODE_Multichannel=7;
const PSDMODE_Duotone=8;
const PSDMODE_Lab=9;

procedure DeflatePSDRLE(pSrcBuf:PByte;pDstBuf:PByte;DstBufSize:integer);
var
  idx:integer;
  len,cnt:integer;
  data:byte;
begin
  idx:=0;

  while(idx<DstBufSize) do begin
    data:=pSrcBuf^;
    inc(pSrcBuf);
    if data<128 then begin
      len:=data+1;
      for cnt:=0 to len-1 do begin
        pDstBuf^:=pSrcBuf^;
        inc(pSrcBuf);
        inc(pDstBuf);
        inc(idx);
      end;
      end else begin
      len:=256-data+1;
      data:=pSrcBuf^;
      inc(pSrcBuf);
      for cnt:=0 to len-1 do begin
        pDstBuf^:=data;
        inc(pDstBuf);
        inc(idx);
      end;
    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  tmp32:dword;
  len,idx:integer;
  x,y:integer;
  data:byte;
  SrcBuf,DstBuf0,DstBuf1,DstBuf2,DstBuf3:array of byte;
  data0,data1,data2,data3:byte;
  DstRGB:TRGB;
begin
  rfs:=TFileStream.Create('130\rgb.psd',fmOpenRead);

  with PSDHead do begin
    for idx:=0 to 4-1 do begin
      Signature[idx]:=char(rfs8bit);
    end;
    Version:=rfs16bit;
    rfsskip(6); // reserved
    Channels:=rfs16bit;
    Height:=rfs32bit;
    Width:=rfs32bit;
    BitPerChannel:=rfs16bit;
    Mode:=rfs16bit;

    // Mode Data
    len:=rfs32bit;
    if len<>768 then begin
      rfsskip(len);
      for idx:=0 to 256-1 do begin
        Palette[idx].b:=0;
        Palette[idx].g:=0;
        Palette[idx].r:=0;
      end;
      end else begin
      for idx:=0 to 256-1 do begin
        Palette[idx].r:=rfs8bit;
      end;
      for idx:=0 to 256-1 do begin
        Palette[idx].g:=rfs8bit;
      end;
      for idx:=0 to 256-1 do begin
        Palette[idx].b:=rfs8bit;
      end;
    end;

    // Image Resources
    len:=rfs32bit;
    rfsskip(len);

    // Reserved Data
    len:=rfs32bit;
    rfsskip(len);

    Compression:=rfs16bit;

    ImageDataOffset:=rfsGetPos;

    RLETableCount:=Height*Channels;
    setlength(RLESizeTable,RLETableCount);

    rfsSetPos(ImageDataOffset);
    for idx:=0 to RLETableCount-1 do begin
      RLESizeTable[idx]:=rfs16bit;
    end;

    RLEDataOffset:=rfsGetPos;

    setlength(RLEOffsetTable,RLETableCount);

    RLEOffsetTable[0]:=RLEDataOffset;
    for idx:=1 to RLETableCount-1 do begin
      RLEOffsetTable[idx]:=RLEOffsetTable[idx-1]+RLESizeTable[idx-1];
    end;

    RLESizeMax:=0;
    for idx:=0 to RLETableCount-1 do begin
      if RLESizeMax<RLESizeTable[idx] then RLESizeMax:=RLESizeTable[idx];
    end;
  end;

  Memo1.Clear;

  with PSDHead do begin
    Memo1.Lines.Add(format('Signature=%s%s%s%s',[Signature[0],Signature[1],Signature[2],Signature[3]]));
    Memo1.Lines.Add(format('Version=$%0.4x',[Version]));
    Memo1.Lines.Add(format('Channels=%d',[Channels]));
    Memo1.Lines.Add(format('Height=%d',[Height]));
    Memo1.Lines.Add(format('Width=%d',[Width]));
    Memo1.Lines.Add(format('BitPerChannel=%d',[BitPerChannel]));
    Memo1.Lines.Add(format('Mode=%d',[Mode]));
    Memo1.Lines.Add(format('Compression=%d',[Compression]));
    Memo1.Lines.Add(format('ImageDataOffset=$%0.8x',[ImageDataOffset]));
    Memo1.Lines.Add(format('RLEDataOffset=$%0.8x',[RLEDataOffset]));

    for idx:=0 to 256-1 do begin
      Memo1.Lines.Add(format('Palette(%d)=RGB:%0.2x%0.2x%0.2x',[idx,Palette[idx].r,Palette[idx].g,Palette[idx].b]));
    end;

    for idx:=0 to Height-1 do begin
      Memo1.Lines.Add(format('RLETable(%d)=$%0.8x:$%0.8x',[idx,RLEOffsetTable[idx],RLESizeTable[idx]]));
    end;
  end;

  MakeBlankImg(prvimg,pf24bit);

  setlength(SrcBuf,PSDHead.RLESizeMax);
  setlength(DstBuf0,PSDHead.Width);
  setlength(DstBuf1,PSDHead.Width);
  setlength(DstBuf2,PSDHead.Width);
  setlength(DstBuf3,PSDHead.Width);

  for y:=0 to PSDHead.Height-1 do begin
    with PSDHead do begin
      if Mode=PSDMODE_Bitmap then begin
        if 1<=PSDHead.Channels then begin
          rfsSetPos(RLEOffsetTable[(Height*0)+y]);
          rfs.ReadBuffer(SrcBuf[0],RLESizeTable[(Height*0)+y]);
          DeflatePSDRLE(@SrcBuf[0],@DstBuf0[0],(Width+7) div 8);
        end;
        end else begin
        if 1<=PSDHead.Channels then begin
          rfsSetPos(RLEOffsetTable[(Height*0)+y]);
          rfs.ReadBuffer(SrcBuf[0],RLESizeTable[(Height*0)+y]);
          DeflatePSDRLE(@SrcBuf[0],@DstBuf0[0],Width);
        end;
        if 2<=PSDHead.Channels then begin
          rfsSetPos(RLEOffsetTable[(Height*1)+y]);
          rfs.ReadBuffer(SrcBuf[0],RLESizeTable[(Height*1)+y]);
          DeflatePSDRLE(@SrcBuf[0],@DstBuf1[0],Width);
        end;
        if 3<=PSDHead.Channels then begin
          rfsSetPos(RLEOffsetTable[(Height*2)+y]);
          rfs.ReadBuffer(SrcBuf[0],RLESizeTable[(Height*2)+y]);
          DeflatePSDRLE(@SrcBuf[0],@DstBuf2[0],Width);
        end;
        if 4<=PSDHead.Channels then begin
          rfsSetPos(RLEOffsetTable[(Height*3)+y]);
          rfs.ReadBuffer(SrcBuf[0],RLESizeTable[(Height*3)+y]);
          DeflatePSDRLE(@SrcBuf[0],@DstBuf3[0],Width);
        end;
      end;
    end;

    case PSDHead.Mode of
      PSDMODE_Bitmap: begin
        with PSDHead do begin
          for x:=0 to integer(Width)-1 do begin
            data0:=DstBuf0[x div 8];
            data0:=(data0 shr (7-(x and 7))) and 1;
            if data0=0 then begin
              data0:=$ff;
              end else begin
              data0:=$00;
            end;
            prvimg.Canvas.Pixels[x,y]:=rgb(data0,data0,data0);
          end;
        end;
      end;
      PSDMODE_Grayscale: begin
        with PSDHead do begin
          for x:=0 to integer(Width)-1 do begin
            data0:=DstBuf0[x];
            prvimg.Canvas.Pixels[x,y]:=rgb(data0,data0,data0);
          end;
        end;
      end;
      PSDMODE_Indexed: begin
        with PSDHead do begin
          for x:=0 to integer(Width)-1 do begin
            DstRGB:=Palette[DstBuf0[x]];
            prvimg.Canvas.Pixels[x,y]:=rgb(DstRGB.r,DstRGB.g,DstRGB.b);
          end;
        end;
      end;
      PSDMODE_RGB: begin
        with PSDHead do begin
          for x:=0 to integer(Width)-1 do begin
            data0:=DstBuf0[x];
            data1:=DstBuf1[x];
            data2:=DstBuf2[x];
            prvimg.Canvas.Pixels[x,y]:=rgb(data0,data1,data2);
          end;
        end;
      end;
      PSDMODE_CMYK: begin
        with PSDHead do begin
          for x:=0 to integer(Width)-1 do begin
            data0:=DstBuf0[x]; // C
            data1:=DstBuf1[x]; // M
            data2:=DstBuf2[x]; // Y
            data3:=$ff-DstBuf3[x]; // K
            data0:=max($00,data0-data3);
            data1:=max($00,data1-data3);
            data2:=max($00,data2-data3);
            prvimg.Canvas.Pixels[x,y]:=rgb(data0,data1,data2);
          end;
        end;
      end;
      PSDMODE_Multichannel: begin
        with PSDHead do begin
          for x:=0 to integer(Width)-1 do begin
            data0:=DstBuf0[x]; // C
            data1:=DstBuf1[x]; // M
            data2:=DstBuf2[x]; // Y
            prvimg.Canvas.Pixels[x,y]:=rgb(data0,data1,data2);
          end;
        end;
      end;
      PSDMODE_Duotone: begin
        with PSDHead do begin
          for x:=0 to integer(Width)-1 do begin
            data0:=DstBuf0[x];
            prvimg.Canvas.Pixels[x,y]:=rgb(data0,data0,data0);
          end;
        end;
      end;
      PSDMODE_Lab: begin
      end;
    end;
  end;

  rfs.Free;
end;

end.
